import os
import csv
import sys
import math
import numpy
import pandas 
import logging
import networkx
import matplotlib.pyplot as plt
import plotly.express as px


# Suppressing Warning
import warnings
import matplotlib.cbook
warnings.filterwarnings("ignore",category=matplotlib.cbook.mplDeprecation)


# Importing CSV File
df = pandas.read_csv('/Users/undi69/Desktop/PythonForMe/Reference.csv', header=None)
# df = pandas.read_csv('/Users/undi69/Desktop/PythonForMe/SS.csv', header=None)
# df2 = pandas.read_csv('/Users/undi69/Desktop/PythonForMe/testt.csv', header=None)

# Selecting Rows and Columns
df2 = df.iloc[30:130, 143:243]
# df2 = df.iloc[20:215, 65:260]
# df2 = df.iloc[]

# --------------------- Pearson Correlation ---------------------------
'''
Pairwise correlation of all columns (without heatmap)
CorMatrix= df.corr(method='pearson',min_periods=1)
print(CorMatrix)
numpy.savetxt("CorrelationMatrix.csv", CorMatrix, delimiter=",")

M = numpy.absolute(CorMatrix)
plt.matshow(M)
plt.colorbar()
plt.show()
'''
# --------------------- AutoCorrelation WK Theorem---------------------
mean = numpy.mean(numpy.mean(df2))
df3 = numpy.subtract(df2, mean)
summing = numpy.sum(numpy.sum(numpy.power(df3, 2)))
normalize_coeff = numpy.sqrt(summing)
df4 = numpy.true_divide(df3, normalize_coeff)
fftI = numpy.fft.fft2(df4)
inner = numpy.fft.ifft2(numpy.multiply(fftI, fftI.conjugate()))
shifting = numpy.fft.fftshift(inner)
CorMatrix = shifting.real

# print(CorMatrix)

# numpy.savetxt("CorrelationMatrix.csv", CorMatrix, delimiter=",")
numpy.fill_diagonal(CorMatrix, 0)
M = numpy.absolute(CorMatrix)

'''
plt.matshow(M)
plt.colorbar()
plt.show()


# Size of Matrix
rows = CorMatrix.shape[0]
# Build Identity Matrix
IdeMatrix = numpy.identity(rows)
# Subtract Identity Matrix from Correlation Matrix
M = numpy.subtract(CorMatrix,IdeMatrix)
# Taking Absolute Values of elements in M
AdjMatrix = numpy.absolute(M)
'''

#----------------------------------------- For multiple thresholds --------------------------------------------

'''
# Creating a linearly spaced list
threshold = numpy.linspace(0,1,20)
edge = []
degree = []

for x in threshold:

    # Duplicating Adjacency Matrix
    Duplicate = AdjMatrix.copy()

    # Applying a Threshold
    Duplicate[Duplicate >= x] = 1
    Duplicate[Duplicate < x] = 0

    # A DiGraph stores nodes and edges with optional data, or attributes.
    G = networkx.DiGraph(Duplicate.values)

    # Number of edges and nodes
    nodes = G.number_of_nodes()
    edges = G.number_of_edges()
    edge.append(edges)

    # degrees in network
    degrees = [G.degree(n) for n in G.nodes()]
    degree.append(degrees)
        
    # plt.hist(degrees, 10)
    # plt.show()



# Plotting threshold vs # of edges
plt.plot(threshold,edge)
plt.yscale('log')
plt.show()
'''

#----------------------------------------- For 1 threshold --------------------------------------------
# Applying a Threshold
M[M >= 0.2] = 1
M[M < 0.2] = 0

# A DiGraph stores nodes and edges with optional data, or attributes.
# G = networkx.Graph(M)
G = networkx.MultiGraph(M)

# Number of edges and nodes
nodes = G.number_of_nodes()
edges = G.number_of_edges()
print('Nodes: %d , Edges: %d' % (G.number_of_nodes(), G.number_of_edges()))

# Giant Component
# G = G.to_undirected()
print('Connected Components: %d' % networkx.number_connected_components(G))
largest_cc = max(networkx.connected_components(G), key=len)
# print(largest_cc)

giant = max(networkx.connected_component_subgraphs(G), key=len)
print('Giant Nodes: %d , Giant Edges: %d' % (giant.number_of_nodes(), giant.number_of_edges()))

'''
# Average Clustering Coefficient 
# G=networkx.complete_graph(giant.number_of_nodes())
print('Average Clustering Coefficient: %f' % (networkx.average_clustering(G,nodes=None, weight=None,  count_zeros=True)))

# Number of Triangles
# G = G.to_undirected()
print('Number of Triangles:') # %d' %  (networkx.triangles(G, nodes=None)))
print(networkx.triangles(G, nodes=None))

# Average Path Length
print('Average Shortest Path Length: %f' % (networkx.average_shortest_path_length(G)))

# Average Degree
# print('Average Degree: %f' % (degrees/nodes))
'''

# degrees in network
degrees = [giant.degree(n) for n in giant.nodes()]

plt.hist(degrees, 5) #bins='auto')
# plt.show()

# Degree Distribution
value = sorted(set(degrees))
# print(value)
hist = [degrees.count(x) for x in value]
# print(hist)


# plt.figure()
# plt.scatter(value,hist) 
# plt.xlabel('Degree')
# plt.ylabel('Number of nodes')
# plt.title('Degree Distribution')
# plt.show()

#----------------------------------------- Gephi Files --------------------------------------------
# Print Gephi Files
networkx.write_gexf(giant,"testRef55.gexf")
# networkx.write_gexf(giant,"testSS2.gexf")

# Print Degrees in CSV
# numpy.savetxt("degrees9.csv", degrees, delimiter=",")
