% myFolder = '/Users/undi69/Desktop/Matrix-20/Backward in time';
clear all;
clc;

myFolder = pwd;

if ~isdir(myFolder)
  errorMessage = sprintf('Error: The following folder does not exist:\n%s', myFolder);
  uiwait(warndlg(errorMessage));
  return;
end

files = dir(fullfile(myFolder, '*.csv'));
% Pre-allocate data storage
data = cell(size(files));
DP = zeros(76800, numel(files)); % preallocate matrix

% Initial Data
Xcenter = 150;
Ycenter = 120;
radius = 100;

for k = 1:numel(files)
    data{k} = csvread(fullfile(myFolder, files(k).name));
    
    DATA = data{k};
    SIZE = size(DATA);
    
    A = zeros(76800,1);
    a = 1;
    
    for i = 1:SIZE(1)
        for j = 1:SIZE(2)
            if (((i-Xcenter)^2 + (j-Ycenter)^2) <= radius^2)
                A(a) = DATA(i,j);
                a = a + 1;
            end
        end
    end

    AA = nonzeros(A);
    matrix(:,k) = AA;
end

% xlswrite('DataBackward.xlsx',matrix)
xlswrite('DataForward.xlsx',matrix)

